@echo off
TITLE DML WAD Creator
:start
cls
COLOR 0A
echo DIOS-MIOS Lite WAD Creator v0.9 by FIX94
echo.

:MainMenu
echo BC = Download BC
echo DML = Build DIOS-MIOS Lite
echo C = Convert a game with DiscEx
echo E = Exit
echo.
set /p choice="Choice: "
if %choice%==BC (goto BC)
if %choice%==bc (goto BC)
if %choice%==DML (goto DML)
if %choice%==dml (goto DML)
if %choice%==C (goto DiscEx)
if %choice%==c (goto DiscEx)
if %choice%==E (exit)
if %choice%==e (exit)
goto start

:BC
echo.
echo Getting BC...
echo.
echo Checking files...
if not exist nusd.exe (echo nusd.exe not found! & set MissingFiles=1)
if not exist md5.exe (echo md5.exe not found! & set MissingFiles=1)
echo All files found.
echo.
if exist RVL-BC-v6.wad (
md5 -cD1593A77E24ECC95AF2B393ABE5D92F0 RVL-BC-v6.wad
if errorlevel 1 (
set wadfile=RVL-BC-v6.wad
goto BadWad
)
echo BC WAD already exist and is valid!
goto eof
)
echo Downloading BC, please wait...
nusd 0000000100000100 6 packwad
move 0000000100000100\0000000100000100.wad RVL-BC-v6.wad
rmdir 0000000100000100 /s /q
echo.
md5 -cD1593A77E24ECC95AF2B393ABE5D92F0 RVL-BC-v6.wad
if errorlevel 1 (
set wadfile=RVL-BC-v6.wad
goto BadWad
)
goto BCFinish

:DiscEx
:: Check files
cls
if not exist DiscEx.exe (echo DiscEx not found! & set MissingFiles=1)
if not exist libeay32.dll (echo libeay32.dll not found! & set MissingFiles=1)
if not exist msvcr100.dll (echo msvcr100.dll not found! & set MissingFiles=1)
if defined MissingFiles (goto DiscExNotFound)
:: Input
echo Drag your ISO onto this window and press Enter
set /p gameiso="Game ISO: "
:: If there are any quotation marks in the string, they need to be removed
for /f "useback tokens=*" %%a in ('%gameiso%') do set gameiso=%%~a

:: Ask about compression
:PromptCompress
cls
echo Do you want to compress your game?
echo Y = Yes (Recommended)
echo N = No
echo.
set /p compress="Choice: "
if %compress%==Y (goto DoCompress)
if %compress%==y (goto DoCompress)
if %compress%==N (goto DontCompress)
if %compress%==n (goto DontCompress)
goto PromptCompress

:DoCompress
echo Please wait while your game is converted.
echo This may take a while depending on the game
DiscEx.exe -c "%gameiso%" >DiscEx.log
echo Done!
echo Move the new game folder to SD:\games\
goto eof

:DontCompress
echo Please wait while your game is converted.
echo This may take a while depending on the game
DiscEx.exe "%gameiso%" >DiscEx.log
echo Done!
echo Move the new game folder to SD:\games\
goto eof

:DML
echo.
echo Building DML...
echo.
echo Checking files...
if not exist DML.elf (echo DML.elf not found! & set MissingFiles=1)
if not exist wadmii.exe (echo wadmii.exe not found! & set MissingFiles=1)
if not exist nusd.exe (echo nusd.exe not found! & set MissingFiles=1)
if not exist libWiiSharp.dll (echo libWiiSharp.dll not found! & set MissingFiles=1)
if not exist md5.exe (echo md5.exe not found! & set MissingFiles=1)
if not exist FixELF\FixELF.exe (echo FixELF\FixELF.exe not found! & set MissingFiles=1)
if defined MissingFiles (goto FileNotFound)
echo All files found.
echo.

for %%A in ("%~dp0.") do set name=%%~nA

if exist RVL-mios-v10.wad (
md5 -c851C27DAE82BC1C758BE07FA964D17CB RVL-mios-v10.wad
if errorlevel 1 goto BadWad
) else goto MIOS
goto createdmlwad


:MIOS
echo Downloading MIOS, please wait...
nusd 0000000100000101 10 packwad
move 0000000100000101\0000000100000101.wad RVL-mios-v10.wad
rmdir 0000000100000101 /s /q
echo.
md5 -c851C27DAE82BC1C758BE07FA964D17CB RVL-mios-v10.wad
if errorlevel 1 (
set wadfile=RVL-mios-v10.wad
goto BadWad
)

:createdmlwad
echo Creating DML WAD, please wait...
wadmii -in RVL-mios-v10.wad -out mios-v10
FixELF\FixELF.exe mios-v10\00000001.app DML.elf mios-v10\0000001.app
del mios-v10\00000001.app
rename mios-v10\0000001.app 00000001.app

Set _dummy=%name:DMLr=%
IF NOT "%_dummy%" == "%name%" (goto RevDefined)
::The folder does not have DMLr in the name, so we have to ask the revision
echo What revision are you building?
set /p revision="Revision: "
set name=DMLr%revision%

:RevDefined
wadmii -in mios-v10 -out "%name%[MIOS-v10].wad"
rmdir mios-v10 /s /q
goto DMLFinish

:BadWad
COLOR 0C
echo Your %wadfile% is bad. The file will be deleted.
echo Please run the Creator again to re-download it.
DEL %wadfile%
goto eof

:FileNotFound
COLOR 0C
echo.
echo Make sure all files of the WAD Creator package and the
echo DML package are extracted properly to this folder.
goto eof

:DiscExNotFound
COLOR 0C
echo.
echo Download DiscEX-v0.8-cred.rar from the DML google code 
echo page and extract its contents to this folder
goto eof

:BCFinish
echo.
echo BC has been successfully created.
echo Install RVL-BC-v6.wad with a wad manager.
goto eof

:DMLFinish
echo.
echo DML has been successfully created.
echo Install %name%[MIOS-v10].wad with a wad manager.

:eof
echo.
pause
